/******************************************************************************
** 
 * \file      main.c
 * \author    Jesús Martin palomino Velezaquez 
 * \date        
 * \brief     Demo code of lcd 2x16 based on the library for stm32f103xx family
 * \note        
 * \version     
 * \ingroup     
 * \remarks     
 *              
 *
******************************************************************************/

#include <stdio.h>
#include "wm_hal.h"
#include "LCD_2x16.h"
#include "gpio.h"


LCD_HandleTypeDef lcd;
short int cont=0;

int main(void)
{
  
 SystemClock_Config(CPU_CLK_160M);
 
  HAL_Init();
  GPIO_Init();
	
  lcd.RS.Port = GPIOB;      
  lcd.RS.Pin = GPIO_PIN_15;
  
  lcd.EN.Port = GPIOB;
  lcd.EN.Pin = GPIO_PIN_10;
  
  lcd.DB4.Port = GPIOB;
  lcd.DB4.Pin = GPIO_PIN_11;
  
  lcd.DB5.Port = GPIOB;
  lcd.DB5.Pin = GPIO_PIN_16;
  
  lcd.DB6.Port = GPIOB;
  lcd.DB6.Pin = GPIO_PIN_17;
  
  lcd.DB7.Port = GPIOB;
  lcd.DB7.Pin = GPIO_PIN_18;
	
  
  HAL_Delay(100);
  LCD_sendCmd(&lcd, 0x33); // Initialize controller
  LCD_sendCmd(&lcd, 0x32); // Set 4-bit mode
  LCD_sendCmd(&lcd, 0x28); // 4 bit, 2 line, 5x7
  LCD_sendCmd(&lcd, 0x06); // Cursor direction -> right
  LCD_sendCmd(&lcd, 0x0C); // Display on, cursor off
  LCD_sendCmd(&lcd, clear); // Clear display
  HAL_Delay(100);


 short int ed=0; 	
 int line = 0, position = 4;
 LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
 LCD_TEXT(&lcd,"HELLO_WORLD");
 HAL_Delay(2000);
 LCD_sendCmd(&lcd, clear);
 LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
 LCD_TEXT(&lcd,"COUNTER");
 line = 1, position = 7;
 
 while (1)
  {
    for(cont=0; cont<=100; cont++){
	   
       if(cont<10)ed=1;
	   if((cont>=10)&&(cont<100)) ed=2;
	   if(cont==100)ed=3; 
       LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
	   LCD_INT(&lcd,cont,ed);
	   HAL_Delay(1000);
	}   
       LCD_sendCmd(&lcd, clear);
	   line = 0, position = 4;
       LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
	   LCD_TEXT(&lcd,"COUNTER");
	   line = 1, position = 7;
  }
   
    
}

void Error_Handler(void)
{
    while (1)
    {
    }
}

void assert_failed(uint8_t *file, uint32_t line)
{
    printf("Wrong parameters value: file %s on line %d\r\n", file, line);
}